
TIME                     ST Programmer's Manual                  TIME

NAME
     time - time execution of a program

SYNOPSIS
     time [-dl] prog [args...]

DESCRIPTION
     Time measures the time required to execute a given program.

-d   If the option -d (lower case) is specified, time will assume
     it was executed from the desktop, and hold the screen, waiting
     for a keypress, after completion.

-l   If the option -l (lower case) is specified, time will list the
     path and program name combinations as it searches for the program.

     The arguments -d and -l may be combined into -dl. The program to be
     measured is entered on the command line normally, except that the
     program name is preceeded by the program name "time " and possibly
     by any of "time "'s optional arguments, d and/or l. The target program
     is executed normally. After it is completed, time prints the elapsed
     time since the program was initiated, then time itself exits. The
     format of the time printout is MM:SS.FF where MM is the number of
     minutes, SS is the number of seconds, and FF is the fractional part
     of seconds in hundredths. Since time executes the target program via
     a Pexec() function call, there will be slightly less memory available
     for the target program than normal.
     
BUGS
     The is a terrible lack of standardization in the use of the
     "PATH=" environment variable. "time " defaults to the "PATH="
     syntax of Micro C-Shell from Beckemeyer Development Tools.
     Setting the compiler option "MWC" during compilation will change
     the syntax to one compatible with Mark Williams C. There is a
     last chance search of the current directory in case the original
     COMMAND.TOS is being used.

     "time " reads the system 200hz counter rather than set up an
     interrupt vector. This may cause the elapsed time to vary by
     one or two hundredths of a second on identical executions.

AUTHOR
     George R. Woodside           PPN 76537,1342
     5219 San Feliciano Drive
     Woodland Hills, Ca. 91364

Printed 01/09/87                                                1
