/*
 * getenv: get variables from the environment.
 *
 * NOTE: getenv will ONLY work if you are using the Atari developers kit.
 *       If you use a different C compiler, you will need to replace the
 *       import of _base with whatever your C compiler uses as a pointer
 *       to the basepage of the current process.
 *
 *       also, this code assumes that characters are SIGNED and that sign-
 *       extention will* take place when you do (*p >= 0). The GEM environment
 *       is terminated by any* character >= 0x80, so if *p doesn't sign extend,
 *       getenv will probably return garbage for any undefined variables.
 *
 * revisions:
 * 01-jul-86 orc:	written.
 * 11-jan-87 orc:	cleanup for QT release.
 *
 */

/* (*_base)[0x2c] points at the environment */

#define OLDENV() (*((char**)((*_base)+0x2c)))

extern char **_base;	/* in gemstart.s: pointer to the basepage */


char *
_getenv(name)
/* return a pointer to the name= part of a environment string */
register char *name;
{
    register char *p = OLDENV();
    register int len = strlen(name);
    
    while (*p >= 0 /* sign extention is assumed! */) {
	if (strncmp(p,name,len) == 0 && (p[len] == '=' || p[len] == 0))
	    return p;
	p += 1+strlen(p);
	if (p[-2] == '=' && *p >= 0 /* sign extention is assumed! */)
	    p += 1+strlen(p);
    }
    return 0L;
} /* _getenv */



char *
getenv(name)
/* return a pointer to the value of an environment variable */
char *name;
{
    register char *p;

    if(p = _getenv(name)) {
	if (p[strlen(p)-1] == '=')
	    return &p[1+strlen(p)];
	else
	    return "";
    }
    else
	return 0L;
} /* getenv */
