/*
 * lpexec.c: execute a process found someplace in $PATH.
 *           lpexec looks in '.' first, then down the path,
 *           if it exists.
 *           lpexec assumes that the elements in the pathname
 *           are separated by ';' (just like MS-DOS.)
 *
 * written 24-jan-87 by Orc (David Parsons)
 */

#include <osbind.h>

#define NULL	((char*)0)

static char *tails[] = { ".tos", ".ttp", ".prg", 0L };



long
lpexec(name,tail,environ)
/* execute name after finding it someplace on disk */
char *name, *tail, *environ;
{
    char expname[80];		/* unambiguised pathname */
    char *getenv(), *strchr();
    char *env, *etp;
    int dotp = strchr(name,'.');
    int slashp = strchr(name,'\\') || strchr(name,':');

    strcpy(expname,name);			/* check out . first */
    if (lookupfile(expname, dotp?NULL:tails))
	return Pexec(0, expname, tail, environ);

    if (env && !slashp)
	do {
	    if (etp = strchr(env,';')) {
		strncpy(expname, env, (int)(etp-env));
		expname[(int)(etp-env)] = 0;
		env = 1+etp;
	    }
	    else {
		strcpy(expname, env);
		env = NULL;
	    }
	    strcat(expname, name);
	    if (lookupfile(expname, dotp?NULL:tails))
		return Pexec(0, expname, tail, environ);
	} while (env);
    return -33L;	/* file not found... */
} /* lpexec */



lookupfile(fn,tails)
/* look for fn, appending extentions */
register char *fn, **tails;
{
    register char *exp;

    if (Fattrib(fn,0,0) >= 0)	/* does the simple file exist? */
	return 1;

    if (tails) {		/* if not, try some extentions */
	exp = &fn[strlen(fn)];
	while (*tails) {
	    strcpy(exp, *tails++);
	    if (Fattrib(fn,0,0) >= 0)
		return 1;
	}
    }
    return 0;
} /* lookupfile */
