/*
 * qt: a quick and dirty modem program for the Atari ST.
 *
 * qt.h -- global declarations and #defines.
 *
 * revisions:
 *  10-jan-87 orc:	header stuff put in its very own file.
 *  18-jan-87 orc:	i/o defines commented out & replaced with functions.
 *  23-jan-87 orc:	carrier detect polling (MFP) define put in.
 *  25-jan-87 orc:	xmodem stuff put in xmodem.h
 *  21-feb-87 orc:	ESCAPE made into a variable, version 'Lim [1.4-e] e->0'
 */
#include <stdio.h>

#define B_2400	4
#define B_1200	7
#define B_300	9

#define CSIZE	81

#define TRUE	(1==1)
#define FALSE	(1==0)

FILE *fopen();
char *strchr();
char *malloc();

long gemdos(), xbios(), bios();

#define	println()		conString("\r\n")

#define dopen(fn,mode)		gemdos(0x3d,(fn),(mode))
#define dcreat(fn,perm)		gemdos(0x3c,(fn),(perm))
#define dread(fd,ptr,size)	gemdos(0x3f,(fd),((long)(size)),(ptr))
#define dwrite(fd,ptr,size)	gemdos(0x40,(fd),((long)(size)),(ptr))
#define dclose(fd)		gemdos(0x3e,(fd))
#define dunlink(fn)		gemdos(0x41,(fn))

#define dsetdta(p)		gemdos(0x1a, (p))
#define dfirst(fn,attr)		gemdos(0x4e, (fn), (attr))
#define dnext()			gemdos(0x4f)
#define dfree(drv,p)		gemdos(0x36, (p), (drv))

#define cursconf(f,o)		xbios(21,(f),(o))
#define rsconf(s,f,u,r,t,s)	xbios(15,s,f,u,r,t,s)
#define setexc(vector,func)	bios(5,(vector),(func))
#define jdiabint(intno)		xbios(27,(intno))
#define supexec(f)		xbios(38,f)

#define	offgibit(bit)		xbios(29,bit)
#define	ongibit(bit)		xbios(30,bit)

#define MFP	((char*)0xfffffa01L)

#define ESC	033		/* the 'real' escape character */

#define ERROR	(-1)		/* timeout recieving character */

#define VERSION	"Lim [1.4-e] e->0"
