#define TT 0xffff
extern long xbios();

int intin[64],intout[64],contrl[12],ptsin[64],ptsout[64],c,gl_apid;

int array[104][52],pxy[10],pal[16],handle,offset,i,j,*base;

int palette[16] = {     /* Color definitions for "rainbow" */
 0x000,0x700,0x730,0x750,0x770,0x470,0x070,0x075,0x077,0x057,0x027,
 0x007,0x507,0x707,0x704,0x777 };

int curform[37] = {     /* Box cursor mouse form definition */
 2,2,1,0,1,
 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 0xf800,0x8800,0x8800,0x8800,0xf800,0,0,0,0,0,0,0,0,0,0,0 };

/* Continue and Live tables (for faster color cycling) */
int cotab[16]={0,2,3,4,5,6,7,8,9,10,11,12,13,14,15,15};
int litab[16]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,15};

/* Tables for fast plot routine */
int bits[4]={0xe000,0x0e00,0x00e0,0x000e};
int ebit[4]={0x0fff,0xf0ff,0xff0f,0xfff0};
int bit0[16]={0,TT,0,TT,0,TT,0,TT,0,TT,0,TT,0,TT,0,TT};
int bit1[16]={0,0,TT,TT,0,0,TT,TT,0,0,TT,TT,0,0,TT,TT};
int bit2[16]={0,0,0,0,TT,TT,TT,TT,0,0,0,0,TT,TT,TT,TT};
int bit3[16]={0,0,0,0,0,0,0,0,TT,TT,TT,TT,TT,TT,TT,TT};

/* Count number of ON neighbors for cell x,y */

count_n(x,y)
int x,y;
{
  register int *aptr,n;

  aptr=&(array[x+offset-1][y-1]);

  asm {            /* Straight 68000 is faster than compiled C */
         move.w #0,n
         move.w (aptr),D0
         beq    l01
         addi.w #1,n
    l01: move.w 2(aptr),D0
         beq    l02
         addi.w #1,n
    l02: move.w 4(aptr),D0
         beq    l10
         addi.w #1,n
    l10: move.w 104(aptr),D0
         beq    l12
         addi.w #1,n
    l12: move.w 108(aptr),D0
         beq    l20
         addi.w #1,n
    l20: move.w 208(aptr),D0
         beq    l21
         addi.w #1,n
    l21: move.w 210(aptr),D0
         beq    l22
         addi.w #1,n
    l22: move.w 212(aptr),D0
         beq    ldo
         addi.w #1,n
    ldo: move.w D0,D0
  }
  return(n);
}

/* Do one generation on the grid. */

do_grid()
{
  register int x,y,o;
  int n,xo;

  for (x=1; x<49; ++x)
  {
    xo=x+52-offset;
    for (y=1; y<51; ++y)
    {
      n=count_n(x,y); o=array[x+offset][y];
      if (n == 2) array[xo][y] = cotab[array[x+offset][y]];  /* Remain */
      if (n == 3) array[xo][y] = litab[array[x+offset][y]];  /* Live   */
      if ((n<2) || (n>3)) array[xo][y] = 0;                  /* Die!   */
      if (array[xo][y] != o) plot(x-1,y-1,array[xo][y]);
    }
  }
}

/* Initialize array and let user draw a pattern.  Kludgy, but it works. */

init_array()
{
  int x,y,mx,my,butn;

  for (x=0; x<52; ++x)
    for (y=0; y<52; ++y)
      { array[x][y]=0; array[x+52][y]=0; }
  butn=0;
  while (! (butn & 0x0002))   /* Wait for right button */
  {
    graf_mkstate(&mx,&my,&butn,&x);
    if (butn & 0x0001)        /* Left button is pressed */
    {
      int n;
      x=mx/4+1; y=my/4+1;
      if (x<49)               /* In the workspace? */
      {
        n=(! array[x][y]);
        changcell(x,y,n);
        while (butn & 0x0001)
        {
          graf_mkstate(&mx,&my,&butn,&y);
          changcell(mx/4+1,my/4+1,n);
        }
      }
    }
  }
}

/* Change cell state to ON or OFF (color 1). */

changcell(x,y,state)
int x,y,state;
{
  if (x>48) return(0);
  if (array[x][y] == state) return(0);
  array[x][y]=state;
  v_hide_c(handle);
  plot(x-1,y-1,state);
  v_show_c(handle,0);
}

/* Tie everything together. */

main()
{
  int work_in[11],work_out[57],altkey,dummy,gen;

  appl_init();

  for (i=0; i<16; ++i)            /* Save user's colors. */
    pal[i]=(int)xbios(7,i,-1);

  xbios(6,palette);               /* Install rainbow colors. */
  base=(int *)xbios(2);           /* Get screen address. */

  for (i=0; i<10; work_in[i]=1, ++i);
  work_in[10]=2;
  v_opnvwk(work_in,&handle,work_out);

  v_hide_c(handle);
  v_clrwk(handle);
  vsf_interior(handle,1);
  vsc_form(handle,curform);
  title();
  v_show_c(handle,0);

  offset=0; gen=0;

  init_array();

  v_hide_c(handle);
  altkey=0;
  do
  {
    ++gen;
    printn(gen);
    do_grid();
    offset = 52-offset;
    graf_mkstate(&dummy,&dummy,&dummy,&altkey);
  } while (! altkey);
  xbios(6,pal);
  appl_exit();
  exit(0);
}

/* Plot all the junk on the right side of the screen. */

title()
{
  vsf_color(handle,14);  /* ST color 11 */
  pxy[0]=194; pxy[1]=0;
  pxy[2]=194; pxy[3]=199;
  pxy[4]=319; pxy[5]=199;
  pxy[6]=319; pxy[7]=0;
  pxy[8]=194; pxy[1]=0;
  v_pline(handle,5,pxy);

  vst_color(handle,9);  /* ST color 8 */
  vst_height(handle,28,&i,&i,&i,&i);
  vst_effects(handle,16);
  v_gtext(handle,220,30,"Life!");

  vst_height(handle,6,&i,&i,&i,&i);
  vst_effects(handle,0);
  vst_color(handle,2);   /* ST color 1 */
  v_gtext(handle,208,60,"Steven Grimm");

  vst_color(handle,4);  /* ST color 4 */
  vst_height(handle,4,&i,&i,&i,&i);
  v_gtext(handle,250,49,"by");
  v_gtext(handle,207,88,"ANALOG Computing");
  v_gtext(handle,204,150,"Left button to");
  v_gtext(handle,207,156,"toggle cells.");
  v_gtext(handle,204,165,"Right button to");
  v_gtext(handle,207,171,"begin generation.");
  v_gtext(handle,204,189,"ALT to exit.");

  vst_color(handle,7);  /* ST color 5 */
  v_gtext(handle,204,120,"Generation:");
}

/* Print generation number next to "Generation:". */

printn(num)
int num;
{
  int x,i;
  char c[2];

  c[1]=0;
  x=270;
  for (i=10000; i>0; i /= 10)
  {
    if ((num/i) || (x>270))
    {
      c[0]=(num/i)+48;
      v_gtext(handle,x,120,c);
      num -= (i*(num/i));
      x += 6;
    }
  }
}

/* Special plot routine. */

plot(x,y,color)
int x,y,color;
{
  static int b0,b1,b2,b3,*screen,xbit;
  auto int *eptr;

  screen=base;
  screen += (y*320);
  screen += (x & 0xfffc);

  x = x & 0x0003;
  xbit = bits[x];

  b0 = bit0[color] & xbit;
  b1 = bit1[color] & xbit;
  b2 = bit2[color] & xbit;
  b3 = bit3[color] & xbit;

  eptr=ebit+x;

  asm {
    movea.l screen(A4),A1
    movea.l eptr(A6),A0
    move.w  (A1),D0
    and.w   (A0),D0
    or.w    b0(A4),D0
    move.w  D0,(A1)
    move.w  2(A1),D1
    and.w   (A0),D1
    or.w    b1(A4),D1
    move.w  D1,2(A1)
    move.w  4(A1),D2
    and.w   (A0),D2
    or.w    b2(A4),D2
    move.w  D2,4(A1)
    move.w  6(A1),D3
    and.w   (A0),D3
    or.w    b3(A4),D3
    move.w  D3,6(A1)
    adda.l  #160,A1
    move.w  D0,(A1)
    move.w  D1,2(A1)
    move.w  D2,4(A1)
    move.w  D3,6(A1)
    adda.l  #160,A1
    move.w  D0,(A1)
    move.w  D1,2(A1)
    move.w  D2,4(A1)
    move.w  D3,6(A1)
  }
}
