{********************Tiny Term program start********************}
PROGRAM Terminal (INPUT,OUTPUT);

CONST
  Rs232   = 1;
  Console = 2;

VAR
  Baud,Ctrl,Ucr : INTEGER;
  Rsr,Tsr,Scr   : INTEGER;
  Opt,Speed,Dev : INTEGER;
  Transfer      : CHAR;
  Flg           : BOOLEAN;

{$I d:\myprogs.pas\cursor.pas}

{**********XBIOS and BIOS**********}

PROCEDURE Rs232_Config(Baud,Ctrl,Ucr,Rsr,Tsr,Scr:INTEGER);
  Xbios(15);

PROCEDURE Setup_Cursor(Opt,Speed:INTEGER);
  Xbios(21);

FUNCTION Dvi_In_Stat(Dev:INTEGER):INTEGER;
  Bios(1);

FUNCTION Dvi_Out_Stat(Dev:INTEGER):INTEGER;
  Bios(8);

FUNCTION Dvi_In(Dev:INTEGER):Long_Integer;
  Bios(2);

PROCEDURE Dvi_Out(Dev,Transfer:INTEGER);
  Bios(3);

FUNCTION Kbshift:Long_Integer;
  Bios(11);

{**********Procedures**********}

PROCEDURE Initialize;

BEGIN
  Baud := 7; Ctrl := 1;
  Ucr := 136; Rsr := -1;
  Rsr := -1; Tsr := -1;
  Scr := -1;
  ClrScr;
  WRITELN; WRITELN('Tiny Term V1.0 - By Dan Polfer 07/20/86');
  WRITELN;
  Rs232_Config(Baud,Ctrl,Ucr,Rsr,Tsr,Scr);
  Setup_Cursor(1,0); Setup_Cursor(2,0); Setup_Cursor(4,20);
END; {initialize}

{********************}

FUNCTION In_Phone:CHAR;

VAR
  Rawch   : Long_Integer;

BEGIN
  IF Dvi_In_Stat(Rs232) = -1 THEN BEGIN
    Rawch := Dvi_In(Rs232);
    Rawch := Rawch & $000000ff;
    In_Phone := CHR(Rawch);
    Flg:=TRUE;
    END
  ELSE
    Flg:=FALSE;
END; {in_phone}

{********************}

PROCEDURE Out_Phone;

VAR
  Rawch : Long_Integer;
  Chvl  : INTEGER;
  F     : TEXT;

BEGIN
  Rawch := Dvi_In(Console);
  Rawch := Rawch&$000000ff;
  Transfer:=CHR(Rawch);
  REPEAT UNTIL Dvi_Out_Stat(Rs232) = -1;
  REWRITE(F,'AXO:');
  WRITE(F,Transfer);
END; {out_phone}

{********************}

BEGIN {program}
  Initialize;
  REPEAT
    Transfer:=In_Phone;
    IF Flg THEN WRITE(Transfer);
    IF Keypress THEN Out_Phone;
  UNTIL Transfer='~';
END.

{********************End of program********************}
